<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="100px"
    >
      <el-row>
        <el-form-item label="钥匙编码" prop="keyCode">
          <el-input
            v-model="queryParams.keyCode"
            placeholder="请输入钥匙编码"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>

        <el-form-item label="钥匙名称" prop="keyName">
          <el-input
            v-model="queryParams.keyName"
            placeholder="请输入钥匙名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>

        <el-form-item style="margin-left: 20px">
          <el-button v-no-more-click
            type="primary"
            icon="el-icon-search"
            size="mini"
            @click="handleQuery"
            >搜索
          </el-button>
          <el-button v-no-more-click icon="el-icon-refresh" size="mini" @click="resetQuery"
            >重置
          </el-button>
        </el-form-item>
      </el-row>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button v-no-more-click
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['mes:hw:key:add']"
          >新增
        </el-button>
      </el-col>

      <el-col :span="1.5">
        <el-button v-no-more-click
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['mes:hw:key:batchremove']"
          >批量删除
        </el-button>
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="repairList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column
        label="钥匙编码"
        width="150px"
        align="center"
        prop="keyCode"
      />
      <el-table-column
        label="钥匙名称"
        width="180px"
        align="center"
        prop="keyName"
      />
      <el-table-column
        label="钥匙NFC"
        width="180px"
        align="center"
        prop="keyNfc"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        label="钥匙型号"
        width="180px"
        align="center"
        prop="keySpec"
        :show-overflow-tooltip="true"
      />
      <el-table-column label="MAC地址" align="center" prop="macAddress" />

      <el-table-column label="所属硬件" align="center" prop="hardwareName" />
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        width="180"
      >
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>

      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button v-no-more-click
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['mes:hw:key:edit']"
            >编辑
          </el-button>
          <el-button v-no-more-click
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['mes:hw:key:remove']"
            >删除
          </el-button>
          <!--          <el-button v-no-more-click size="mini" type="text">预览</el-button>-->
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.current"
      :limit.sync="queryParams.size"
      @pagination="getList"
    />

    <!-- 添加或修改设备维修单对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="450px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="所属硬件" prop="hardwareId">
          <el-select
            v-model="form.hardwareId"
            placeholder="请选择所属硬件"
            clearable
            style="width: 100%"
          >
            <el-option
              v-for="dict in this.hardWareList"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-row>
          <el-col :span="15">
            <el-form-item label="钥匙编码" prop="keyCode">
              <el-input
                v-model="form.keyCode"
                placeholder="请输入钥匙编码"
                style="width: 100%"
              />
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label-width="80">
              <el-switch
                v-model="autoGenFlag"
                active-color="#13ce66"
                active-text="自动生成"
                @change="handleAutoGenChange(autoGenFlag)"
              >
              </el-switch>
            </el-form-item>
          </el-col>
        </el-row>

        <el-form-item label="钥匙名称" prop="keyName">
          <el-input v-model="form.keyName" placeholder="请输入钥匙名称" />
        </el-form-item>
        <el-form-item label="钥匙NFC" prop="keyNfc">
          <el-input
            v-model="form.keyNfc"
            placeholder="请输入钥匙Nfc"

          />
        </el-form-item>
        <el-form-item label="MAC地址" prop="macAddress">
          <el-input
            v-model="form.macAddress"
            placeholder="请输入Mac地址"

          />
        </el-form-item>
        <el-form-item label="钥匙型号" prop="keySpec">
          <el-input
            v-model="form.keySpec"
            placeholder="请输入钥匙型号"

          />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button v-no-more-click type="primary" @click="submitForm">确 定</el-button>
        <el-button v-no-more-click @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listKeyAPI,
  addKeyAPI,
  updateKeyAPI,
  delKeyAPI,
  getKeyInfoAPI,
} from "@/api/mes/Keys/Keys";
import { listHardware } from "@/api/mes/hw/hardwareinfo";
import { genCode } from "@/api/system/autocode/rule";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
// import { listHanrwareType } from "@/api/mes/hw/hadrwareType";

export default {
  name: "lock",
  dicts: ["hardware_status"],
  components: { Treeselect },
  data() {
    return {
      autoGenFlag: false,
      optType: undefined,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      codes: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 设备维修单表格数据
      repairList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      createTime: "",
      queryParams: {
        current: 1,
        size: 10,
        keyCode: null,
        keyName: null,
        keyNfc: null,
        macAddress: null,
      },
      hardWareList: [],
      queryhwParams: {
        current: 1,
        size: -1,
      },
      // 表单参数
      form: {
        hardwareId: null,
      },
      // 表单校验
      rules: {
        keyCode: [
          { required: true, message: "钥匙编码不能为空", trigger: "blur" },
        ],
        keyName: [
          { required: true, message: "钥匙名称不能为空", trigger: "blur" },
        ],
        keyNfc: [
          { required: true, message: "钥匙NFC不能为空", trigger: "blur" },
        ],
        macAddress: [
          { required: true, message: "MAC地址不能为空", trigger: "blur" },
        ],
      },
      // 日期选择
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },

      // 新增状态

      EditId: 0, //修改判断
      machinerytypeOptions: [], //锁具机构类型
    };
  },
  created() {
    this.getList();
    this.getHardWare();
  },
  methods: {
    // 硬件信息
    getHardWare() {
      listHardware(this.queryhwParams).then((response) => {
        this.hardWareList = response.data.records.map((item) => {
          return {
            value: item.id,
            label: item.hardwareName,
          };
        });

        // console.log(response, this.hardWareList, "获取硬件信息");
      });
    },
    //自动生成编码
    handleAutoGenChange(autoGenFlag) {
      if (autoGenFlag) {
        genCode("KEY_CODE").then((response) => {
          this.form.keyCode = response;
          // console.log(response, this.form.keyCode, "KeyCode");
        });
      } else {
        this.form.keyCode = null;
      }
    },
    /** 查询设备维修单列表 */

    getList() {
      this.loading = true;

      // 锁具机构数据
      listKeyAPI(this.queryParams).then((response) => {
        this.repairList = response.data.records;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        keyName: null,
        keyCode: null,
        keyNfc: null,
        macAddress: null,
        remark: null,
      };

      this.autoGenFlag = false;
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.current = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.queryParams.keyCode = "";
      this.queryParams.keyName = "";
      this.queryParams.keyId = "";
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.keyId);
      this.codes = selection.map((item) => item.keyCode);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.EditId = null;
      this.title = "新增钥匙信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.EditId = row.keyId || this.ids;
      getKeyInfoAPI(this.EditId).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "编辑钥匙信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.EditId != null) {
            updateKeyAPI(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            // console.log(this.form, "form");
            addKeyAPI(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.EditId = null;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const repairIds = row.keyId || this.ids;
      const repairCodes = row.keyCode || this.codes;
      this.$modal
        .confirm('是否确认删除编码为"' + repairCodes + '"的数据项？')
        .then(function () {
          return delKeyAPI(repairIds);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
  },
};
</script>
<style scoped>
.imgstatus {
  position: relative;
  top: 1px;
  left: 0px;
}

/deep/ .el-radio__inner {
  border-radius: 2px;
}

/deep/ .el-radio__input.is-checked .el-radio__inner::after {
  content: "";
  width: 8px;
  height: 3px;
  border: 1px solid white;
  border-top: transparent;
  border-right: transparent;
  text-align: center;
  display: block;
  position: absolute;
  top: 3px;
  left: 2px;
  transform: rotate(-45deg);
  border-radius: 0pc;
  background: none;
}
</style>
